#include <iostream>
#include <fstream>
#include <ctime>
#include <string>
#include <vector>
#include <iterator>

using namespace std;

const string phraseList[5] = 
{ 
"Now with some formatting!", 
"60% of the time, it works every time.", 
"ID10T Error", 
"Take me down to funky town...", 
"Johnny 5 is ALIVE!" 
};

void phraseoftheday() 
{
	srand(time(0));

	string phrase = phraseList[rand() % size(phraseList)];

	cout << "Lightmapped Shader Generator Thingy by MrC" << endl;
	cout << phrase << endl;
	cout << "" << endl;
}

bool fileExists(string& inputfile)
{
	ifstream ifile(inputfile.c_str());
	return ifile.good();
}

int main(int argc, char* argv[])
{
	if (argc < 3)
	{
		cout << "Too few parameters." << endl;
		cout << "USAGE: " << endl;
		cout << "Shadergen3.exe input: i.e myshaders.txt shader_file_name" << endl;
		return 1;
	}

	string input = argv[1];
	string filename = argv[2];

	ofstream myfile;
	ifstream file(input);

	if (fileExists(input)) 
	{
		cout << input << " found." << endl;
	}
	else
	{
		cout << input << " not found." << endl;
		return 0;
	}

	phraseoftheday();

	myfile.open(filename + ".shader");

	vector<string> names;

	while (file >> input)
	{
		names.push_back(input);
	}

	/*
	for (string name : names)
	{
		cout << name << endl;

		myfile << name << endl
			<< "{" << endl
			<< "	qer_editorimage " << name << endl
			<< "	{" << endl
			<< "		map $lightmap" << endl
			<< "		rgbGen identity" << endl
			<< "		tcGen lightmap" << endl
			<< "	}" << endl
			<< "	{" << endl
			<< "		map " << name << endl
			<< "		rgbGen identity" << endl
			<< "		blendFunc GL_DST_COLOR GL_ZERO" << endl
			<< "	}" << endl
			<< "}" << endl << endl;
	}
	*/

	for (string name : names)
	{
		cout << name << endl;

		myfile << name << endl
			<< "{" << endl
			<< "	qer_editorimage " << name << endl
			<< "	{" << endl
			<< "		map " << "$lightmap" << endl
			<< "		map " << name << endl
			<< "	}" << endl
			<< "}" << endl << endl;
	}

	myfile << endl;

	cout << endl;
	cout << filename << ".shader" << " created." << endl;
	cout << endl;

	//	system("pause");

	return 0;
}